import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public class DmoBoxLayout extends JFrame
{
   private static final String
      TITRE_DFAUT = "Dmo de BoxLayout";
   public DmoBoxLayout (final String Titre)
   {
      super (Titre);
   }
   //
   // Cre une bote, verticale ou horizontale (selon la valeur d'un
   // des paramtres), et y insre un certain nombre de boutons sur
   // lesquels apparatra un prfixe textuel et un suffixe numrique.
   //
   // Notez qu'une Box et un BoxLayout sont deux choses diffrentes.
   //
   private Box CrerBote
      (final int NbBoutons, final String Prfixe, boolean Horizontal)
   {
      //
      // la ligne suivante quivaut 
      //
      // Box b = null;
      // if (Horizontal)
      //    b = Box.createHorizontalBox ();
      // else
      //    b = Box.createVerticalBox ();
      //
      // Vous pouvez utiliser l'une ou l'autre des faons de faire,
      // selon vos prfrences.
      Box b = (Horizontal)? Box.createHorizontalBox () : Box.createVerticalBox ();
      for (int i = 0; i < NbBoutons; i++)
      {
         // On ajoute des contrles  une instance de Box comme on
         // le fait sur un panneau
         b.add (new JButton (Prfixe + i));
      }
      return b;
   }
   //
   // Cre la bote de gauche
   //
   private Box CrerBoteDeGauche ()
   {
      final int NB_BOUTONS = 3;
      final String PRFIXE = "Bouton de gauche ";
      return CrerBote (NB_BOUTONS, PRFIXE, false);
   }
   //
   // Cre la bote centrale
   //
   private Box CrerBoteCentrale ()
   {
      final int NB_BOUTONS = 2;
      final String PRFIXE = "Bouton du centre ";
      return CrerBote (NB_BOUTONS, PRFIXE, true);
   }
   //
   // Cre la bote de droite
   //
   private Box CrerBoteDeDroite ()
   {
      final int NB_BOUTONS = 3;
      final String PRFIXE = "Bouton de droite ";
      return CrerBote (NB_BOUTONS, PRFIXE, false);
   }
   //
   // Initialisation du volet graphique de la fentre
   //
   public void init ()
   {
      getContentPane ().add (CrerBoteDeGauche(), BorderLayout.WEST);
      getContentPane ().add (CrerBoteCentrale(), BorderLayout.CENTER);
      getContentPane ().add (CrerBoteDeDroite(), BorderLayout.EAST);
   }
   public static void main (String [] args)
   {
      DmoBoxLayout dbl = new DmoBoxLayout (TITRE_DFAUT);
      dbl.init ();
      dbl.pack ();
      dbl.addWindowListener
      (
         new WindowAdapter()
         {
            public void windowClosing(WindowEvent e)
            {
               System.exit(0);
            }
         }
      );
      dbl.show ();
   }
}
